
typedef struct matchesS {
	struct matchesS *m_nextP;
	int				m_offset;
	void			*m_codeP;
} matchesT;

typedef struct block_matchesS {
	struct block_matchesS	*m_nextP;
	matchesT				m_cache[8192];
} block_matchesT;

class Cmatch {
private:
	static int				m_matches_lth;
	static matchesT			*m_hash[1<<16];
	static unsigned short	m_next[1<<16];
	static unsigned short	m_first;

	static block_matchesT	*m_head_block_matchesP;
	static block_matchesT	*m_block_matchesP;
	static matchesT	        *m_matches_cacheP;
	static matchesT	        *m_matches_endP;
public:
	static long long		m_comparisons;

	static void init(void);
	static void setup(int lth);
	static void add(int offset, void *code2P);
	static int  test(int offset, void *code2P);
	static void clear(void);
};
