#define VERSION "1.0.9"

#define HTML_HEADER \
"<html>\n" \
"<style>\n" \
"body{background-color:#e0ffff; font-family: Verdana, Arial,sans-serif; font-size:10pt; color:#8b0000}\n" \
"A{color:#000066; text-decoration:none}\n" \
"A:hover{color:blue}\n" \
"A:visited:{color:#000066}\n" \
"</style>\n"

#ifndef SSIZE_MAX
#define SSIZE_MAX 0x7FFFFFFF
#endif

void error_exit(int code);

extern char	label_char[256];
extern char	function_char[256];

void init_lookup_chars(void);
char *end_symbol_name(char *P);

extern char	*cwdP;

char *absolute_path(char *pathP);
void put_html(const char *stringP, FILE *F);
void put_opcode(const char *stringP, FILE *F);
FILE *open_file(const char *filenameP);

extern char	g_filename[FILENAME_MAX];

int getline1(char **, int *, FILE *F);
char *dupstring(const char *stringP);

